/* vim: set ts=8 sw=8 noet: */
/*
 * (C) Copyright 2002 2003
 * Network Audio Technologies, Inc. <www.netaudiotech.com>
 * Adam Bezanson <bezanson@xxxxxxxxxxxxxxxx>
 *
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <ep93xx.h>
#include <i2c.h>
#include <linux/byteorder/swab.h>

#define HAL_WRITE_UINT32( _register_, _value_ ) \
	(*((volatile unsigned long *)(_register_)) = (_value_))

/* ------------------------------------------------------------------------- */

/*
 * static inline void delay (unsigned long loops)
 * {
 *	__asm__ volatile ("1:\n"
 *	 "subs %0, %1, #1\n"
 *	 "bne 1b":"=r" (loops):"0" (loops));
 * }
 */

/*
 * Miscellaneous platform dependent initialisations
 */


extern int ep93xxfb_init(char*);
int board_init (void)
{
    DECLARE_GLOBAL_DATA_PTR;

    icache_enable();

#ifdef USE_920T_MMU
    dcache_enable();
#endif

    /* Machine number, as defined in linux/arch/arm/tools/mach-types */
    gd->bd->bi_arch_number = 386;

    /* adress of boot parameters */
    gd->bd->bi_boot_params = CONFIG_BOOT_PARAM_ADDR;

    /* We have a console */
    gd->have_console = 1;

    return(0);
}

int misc_init_r()
{
    DECLARE_GLOBAL_DATA_PTR;
    char mac[6];

    i2c_init (CFG_I2C_SPEED, CFG_I2C_SLAVE);
    if (! i2c_read(CFG_I2C_EEPROM_ADDR, 0, 1, mac, 6)) {
	  memcpy (gd->bd->bi_enetaddr, mac, 6);
    }
    return(0);
}

int dram_init (void)
{
	DECLARE_GLOBAL_DATA_PTR;

	gd->bd->bi_dram[0].start = PHYS_SDRAM_1;
	gd->bd->bi_dram[0].size = PHYS_SDRAM_SIZE_1;
	gd->bd->bi_dram[1].start = PHYS_SDRAM_2;
	gd->bd->bi_dram[1].size = PHYS_SDRAM_SIZE_2;

	return(0);
}
