/*
 *  Memory sub-system initialization code for TANBAC Evaluation board TB0229.
 *
 *  Copyright (c) 2003  Masami Komiya <mkomiya@sonare.it>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#include <config.h>
#include <version.h>
#include <asm/regdef.h>


	.globl  lowlevel_init
lowlevel_init:
	/* set clock divider */
	/* if ( PMUINTREG & RTCRST ) { */
	la	t0, 0xaf0000c0
	lw	t2, 0(t0)
	andi	t2, t2,0x10
	andi	t2, t2,0xffff
	beq	t2, $0,1f
	/* PMUINTREG = 0xff3b */
	li	t2, 0xff3b
	sh	t2, 0(t0)
	/* PMUTCLKDIVREG = 0x0102 */
	la	t0, 0xaf0000cc
	li	t2, 0x0102
	sh	t2, 0(t0)
	/* PMUCNT2REG = SOFTRST */
	la	t0, 0xaf0000c6
	li	t2, 0x10
	sh	t2, 0(t0)
	/* } */
1:
	/* BCUCNTREG1 = 0x0040 */
	la	t0, 0xaf000000
	li	t1, 0x0040
	sh	t1, 0(t0)

	/* ROMSIZEREG = 0x3333 */
	la	t0, 0xaf000004
	li	t1, 0x3333
	sh	t1, 0(t0)

	/* ROMSPEEDREG = 0x3006 */
	la	t0, 0xaf000006
	li	t1, 0x3006
	sh	t1, 0(t0)

	/* BCUCNTREG3 = 0 */
	la	t0, 0xaf000016
	li	t1, 0x0000
	sh	t1, 0(t0)

	/* CMUCLKMSK */
	la	t0, 0xaf000060
	li	t1, 0x39a2
	sh	t1, 0(t0)

	/* PMUCNTREG */
	la	t0, 0xaf0000c2
	li	t1, 0x0006
	sh	t1, 0(t0)

	/* SDRAMMODEREG = 0x8039 */
	la	t0, 0xaf000400
	li	t1, 0x8039
	sh	t1, 0(t0)

	/* SDRAMCNTREG = 0x2633 */
	la	t0, 0xaf000402
	li	t1, 0x2633
	sh	t1, 0(t0)

	/* BCURFCNTREG = 0x061d */
	la	t0, 0xaf000404
	li	t1, 0x061d
	sh	t1, 0(t0)

	/* RAMSZEREG = 0x5555 (64MB Bank) */
	la	t0, 0xaf000408
	li	t1, 0x5555
	sh	t1, 0(t0)

	j       ra
	nop
