/* vim: set ts=8 sw=8 noet: */
/*
 * Configuration settings for Cirrus Logic EDB93xx boards.
 *
 * Copyright (C) 2004, 2005
 * Cory T. Tusar, Videon Central, Inc., <ctusar@videon-central.com>
 *
 * Original EDB93xx port done by llandre <r&d2@dave-tech.it>
 *
 * Based on the settings found in smdk2410.h, which is
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 * Gary Jennejohn <gj@denx.de>
 * David Mueller <d.mueller@elsoft.ch>
 *
 * See file CREDITS for list of people who contributed to this project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#if !defined(TB0319_H)
#define TB0319_H

#if 0
#define CONFIG_SKIP_LOWLEVEL_INIT 1
#endif

/* -----------------------------------------------------------------------------
 * Initial environment and monitor configuration options.
 *
 * These should be set appropriately for your particular development
 * environment.  Refer to the README for more detailed descriptions.
 */
#define CONFIG_BOOTDELAY		5
#define CONFIG_CMDLINE_TAG		1
#define CONFIG_INITRD_TAG		1
#define CONFIG_SETUP_MEMORY_TAGS	1
#define CONFIG_BOOTARGS			"root=/dev/mtdblock2 ro " \
					"console=ttyAM0,$baudrate dip=::::::dhcp" \
					" console=tty $mtdparts"
#define CONFIG_BOOTFILE			"uImage"
#define CONFIG_BOOTCOMMAND		"run tryboot"
#define CFG_AUTOLOAD			"n" 
#define CONFIG_JFFS2_CMDLINE
#define MTDIDS_DEFAULT		"nor0=tb0319"
#define MTDPARTS_DEFAULT	"mtdparts=tb0319:"\
				"0x40000(uboot),0x40000(ubootenv),0x3E00000(root),0x80000(config)"
#define CONFIG_PREBOOT	"chpart nor0,1\necho \'\n"			\
	"Type \"boot\"		for default way\n"			\
	"Type \"run cram\"		to boot from flash\n"		\
	"Type \"run nfs\"		to boot from NFS\n"		\
	"Type \"run usb\"		to boot from USB-disk\n"	\
	"Type \"run initrd\"	to boot with initrd\'"

#define CONFIG_AUTO_COMPLETE	1
#define CFG_HUSH_PARSER 
#define CFG_PROMPT_HUSH_PS2 ">"
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"uboot_start=60000000\0"					\
	"uboot_size=40000\0"						\
	"env_start=60040000\0"						\
	"env_size=40000\0"						\
	"cram_start=60080000\0"						\
	"cram_size=3E00000\0"						\
	"conf_start=63E80000\0"						\
	"conf_size=80000\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"loadaddr=00400000\0"						\
	"loadaddr2=00600000\0"						\
	"cramfile=rom.img\0"						\
	"rootdev=/dev/sda1\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock2 ro $mtdparts\0"	\
	"nfsargs=setenv bootargs root=/dev/nfs ip=:::::eth0:dhcp "	\
		"nfsroot=$nfsroot ro $mtdparts\0"			\
	"usbargs=setenv bootargs root=$rootdev ro $mtdparts\0"		\
	"userargs=setenv bootargs $bootargs console=ttyAM0,$baudrate "	\
		"console=tty\0"						\
	"load_kernel_cram=fsload $bootfile\0"				\
	"load_kernel_tftp=run checkipaddr&&tftp $loadaddr $bootfile\0"	\
	"load_kernel_nfs=run checknfsbase checkipaddr&&"		\
		"nfs $loadaddr $nfsbase$bootfile\0"			\
	"load_method=nfs cram\0"					\
	"load_kernel=setenv method none; for i in $load_method;" 	\
		"do test $method = none&&if run load_kernel_$i;then "	\
		"setenv method $i; fi; done; test $method != none &&"	\
		"iminfo $loadaddr\0"					\
	"load_initrd_cram=fsload $initrdfile\0"				\
	"load_initrd_tftp=run checkipaddr&&tftp $loadaddr2 $initrdfile\0"	\
	"load_initrd_nfs=run checknfsbase checkipaddr&&"		\
		"nfs $loadaddr2 $nfsbase$initrdfile\0"			\
	"load_initrd=setenv method none; for i in $load_method;" 	\
		"do test $method = none&&if run load_initrd_$i;then "	\
		"setenv method $i; fi; done; test $method != none &&"	\
		"iminfo $loadaddr2\0"					\
	"load_cram_tftp=run checkipaddr&&tftp $loadaddr $cramfile\0"	\
	"load_cram_nfs=run checknfsbase checkipaddr&&"			\
		"nfs $loadaddr $nfsbase$cramfile\0"			\
	"update_method=nfs cram\0"					\
	"load_cram=setenv method none; for i in $update_method;" 	\
		"do test $method = none&&if run load_cram_$i;then "	\
		"setenv method $i; fi; done; test $method != none\0"	\
	"load_uboot_tftp=run checkipaddr&&tftp $loadaddr $ubootfile\0"	\
	"load_uboot_nfs=run checknfsbase checkipaddr&&"			\
		"nfs $loadaddr $nfsbase$ubootfile\0"			\
	"load_uboot=setenv method none; for i in $update_method;"	\
		"do test $method = none&&if run load_uboot_$i;then "	\
		"setenv method $i; fi; done; test $method != none\0"	\
	"cram=if run load_kernel_cram; then run cramargs userargs;"	\
		"bootm;fi\0"						\
	"nfs=if run checknfsroot load_kernel_nfs;then "		\
		"run nfsargs userargs && bootm;fi\0"			\
	"usb=if run load_kernel_cram;then run cramargs usbargs userargs;"\
		"bootm;fi\0"						\
	"initrd=if run load_kernel load_initrd; then "			\
		"run nfsargs userargs;bootm $loadaddr $loadaddr $loadaddr1;"		\
		"fi\0"							\
	"checknfsbase=if test x$nfsbase = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checknfsroot=if test x$nfsroot = x;then "			\
		"echo \"*** ERROR: \'nfsroot\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x$ipaddr = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"init_uboot=protect off $uboot_start +$uboot_size;"		\
		"echo erasing uboot area;"				\
		"erase $uboot_start +$uboot_size\0"			\
	"init_cram=protect off $cram_start +$cram_size;"		\
		"echo erasing cram area;"				\
		"erase $cram_start +$cram_size\0"			\
	"init_env=protect off $env_start +$env_size;"			\
		"echo erasing env area;"				\
		"erase $env_start +$env_size\0"				\
	"init_conf=protect off $conf_start +$conf_size;"		\
		"echo erasing conf area;"				\
		"erase $conf_start +$conf_size\0"			\
	"verify_uboot=if run load_uboot; then "				\
		"echo verifying image;"					\
		"cmp.b $loadaddr $uboot_start $filesize;"		\
		"else test a = b;fi\0"					\
	"verify_cram=if run load_cram; then "				\
		"echo verifying image;"					\
		"cmp.b $loadaddr $cram_start $filesize;"			\
		"else test a = b;fi\0"					\
	"update_uboot=if run load_uboot&&itest $filesize < $uboot_size;"\
 		"then run init_uboot;"					\
		"cp.b $loadaddr $uboot_start $filesize;"			\
		"run verify_uboot && reset;"				\
		"fi\0"							\
	"update_cram=if run load_cram&&itest $filesize < $cram_size;"	\
		"then run init_cram;"					\
		"cp.b $loadaddr $cram_start $filesize;"			\
		"run verify_cram;"					\
		"fi\0"							\
	"bootorder=cram usb nfs\0"					\
	"tryboot=for i in $bootorder; do run $i; done\0"		\
	"mtdids=" MTDIDS_DEFAULT	"\0"				\
	"mtdparts=" MTDPARTS_DEFAULT	"\0"				\
	""



/* -----------------------------------------------------------------------------
 * Do NOT touch anything below this point unless you know what you are doing!
 */

/* -----------------------------------------------------------------------------
 * High level configuration options
 */

/* This is an ARM920T core, in a Cirrus Logic 93xx SoC, on a Cirrus Logic
 * EDB93xx board.  Note that 'make' will set the proper CONFIG_EP93<nn> and
 * CONFIG_EDB93<nn> symbols. */
#define CONFIG_ARM920T
#define CONFIG_EP93XX
#define EP9307

/* input clock of PLL */
#define CONFIG_SYS_CLK_FREQ	14745600 /* the EP9312 has 3.6864MHz input clock */
#define CONFIG_UART_PCLK	CONFIG_SYS_CLK_FREQ    

/* Timer 3 set for 2KHz operation */
#define	CFG_HZ			2048
#undef  CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */


/* #define USE_920T_MMU		1*/
#undef CONFIG_USE_IRQ			/* we don't need IRQ/FIQ stuff */



/* -----------------------------------------------------------------------------
 * Monitor configuration
 *
 * Define the set of commands supported for the various EDB93xx boards, as
 * well as the default monitor prompt and amount of help available.
 */
#if defined(USE_920T_MMU)
#define CONFIG_COMMANDS			(CONFIG_CMD_DFL | \
					 CFG_CMD_JFFS2 | \
					 CFG_CMD_I2C | \
					 CFG_CMD_DATE | \
/*					 CFG_CMD_SPI | */\
					 CFG_CMD_EEPROM | \
					 CFG_CMD_SNTP | \
					 CFG_CMD_BMP | \
					 CFG_CMD_DHCP | \
					 CFG_CMD_PING | \
					 CFG_CMD_MII)

#else
#define CONFIG_COMMANDS			(CONFIG_CMD_DFL | \
					 CFG_CMD_JFFS2 | \
					 CFG_CMD_I2C | \
/*					 CFG_CMD_SPI | */\
					 CFG_CMD_EEPROM | \
					 CFG_CMD_DATE | \
					 CFG_CMD_SNTP | \
					 CFG_CMD_BMP | \
					 CFG_CMD_DHCP | \
					 CFG_CMD_PING | \
					 CFG_CMD_MII & \
					 ~CFG_CMD_CACHE)
#endif  /* defined(USE_920T_MMU) */

#include <cmd_confdefs.h>		/* Must be AFTER any CONFIG_COMMANDS */


#define CFG_PROMPT		       "Arm9# "

/* Enable "long" help in the monitor */
#define	CFG_LONGHELP

#define	CFG_CBSIZE		1024		/* Console I/O Buffer Size	*/
#define	CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define	CFG_MAXARGS		16		/* max number of command args	*/
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size	*/


#define	CFG_LOAD_ADDR		0xC1000000      /* default load address */


/* -----------------------------------------------------------------------------
 * Serial port hardware configuration
 *
 * We default to using serial port 1 at 115200 baud.
 * TODO:  kgdb support has NOT been verified as functional.
 */
#define CONFIG_SERIAL1          	1
#define CONFIG_BAUDRATE			115200
#define CFG_BAUDRATE_TABLE		{ 9600, 19200, 38400, 57600, 115200 }

#if 0
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CONFIG_KGDB_SER_INDEX		1
#define CONFIG_KGDB_BAUDRATE		115200
#endif
#endif


/* -----------------------------------------------------------------------------
 * Network hardware configuration
 *
 * We use the internal EP93xx MAC with and external MII compliant PHY.
 * TODO:  netconsole support has NOT been verified as functional.
 */
#define CONFIG_DRIVER_EP93XX_MAC
#define CONFIG_MII_SUPPRESS_PREAMBLE
#define CONFIG_MII
#define CONFIG_PHY_ADDR			(1)

#undef CONFIG_NETCONSOLE


/* -----------------------------------------------------------------------------
 * Physical memory map
 *
 * The EDB9307, EDB9312, and EDB9315 have 1 bank of SDRAM at 0x00000000
 * consisting of 2x Samsung K4S561632E-TC75 256 Mbit SDRAMs on a 32-bit data
 * bus, for a total of 64 MB of SDRAM.
 */
#define CONFIG_NR_DRAM_BANKS		(2)
#define PHYS_SDRAM_1			(0x00000000)
#define PHYS_SDRAM_SIZE_1		(0x02000000)
#define PHYS_SDRAM_2			(0x04000000)
#define PHYS_SDRAM_SIZE_2		(0x02000000)

#define CFG_MEMTEST_START		(0x00000000)
#define CFG_MEMTEST_END			(0x01F00000)


/* Address in RAM to which boot parameters will be copied from the environment.
 * This must match the kernel is expecting. */
#define CONFIG_BOOT_PARAM_ADDR		(PHYS_SDRAM_1 + 0x100)


/* -----------------------------------------------------------------------------
 * Run-time memory allocations
 *
 * The global data area size (must be > sizeof(gd_t)), stack sizes, and heap
 * size are set using the values below.
 */
#define CFG_GBL_DATA_SIZE		(128)

#define CONFIG_STACKSIZE		(128 * 1024)

#if defined(CONFIG_USE_IRQ)
#define CONFIG_STACKSIZE_IRQ		(4 * 1024)
#define CONFIG_STACKSIZE_FIQ		(4 * 1024)
#endif  /* defined(CONFIG_USE_IRQ) */

#define CFG_MALLOC_LEN			(512 * 1024)


/* -----------------------------------------------------------------------------
 * FLASH and environment organization
 *
 * The EDB9301 and EDB9302 have 1 bank of flash memory at 0x60000000 consisting
 * of 1x Intel TE28F128J3C-150 128 Mbit flash on a 16-bit data bus, for a total
 * of 16 MB of CFI-compatible flash.
 *
 * The EDB9307, EDB9312, and EDB9315 have 1 bank of flash memory at 0x60000000
 * consisting of 2x Micron MT28F128J3-12 128 Mbit flash on a 32-bit data bus,
 * for a total of 32 MB of CFI-compatible flash.
 *
 * dev:    size   erasesize  name
 * mtd0: 00010000 00002000 "bootloader"
 * mtd1: 00170000 00010000 "kernel"
 * mtd2: 00670000 00010000 "userland"
 * mtd3: 00010000 00002000 "config"
 * 0x00000000-0x00010000 : "bootloader"
 * 0x00010000-0x00180000 : "kernel"
 * 0x00180000-0x007f0000 : "userland"
 * 0x007f0000-0x00800000 : "config"
 * 
 */
#define CFG_FLASH_CFI
#define CFG_FLASH_CFI_DRIVER
#define CFG_MAX_FLASH_BANKS		(1)
#define CFG_MAX_FLASH_SECT		(256)
#define CFG_FLASH_CFI_WIDTH		FLASH_CFI_32BIT
#define CFG_FLASH_USE_BUFFER_WRITE	1

#define PHYS_FLASH_1			(0x60000000)
#define CFG_FLASH_BASE			(PHYS_FLASH_1)
#define CFG_MONITOR_BASE		(CFG_FLASH_BASE)
#define CFG_MONITOR_LEN			(256*1024)

#define CONFIG_ENV_OVERWRITE		/* Vendor parameters are unprotected */
#define CFG_ENV_IS_IN_FLASH
#define CFG_ENV_ADDR			(0x60040000)
#define CFG_ENV_SECT_SIZE		(0x00040000)
#define CFG_ENV_SIZE			(CFG_ENV_SECT_SIZE)
/*
#define CFG_ENV_ADDR_REDUND		(0x60080000)
#define CFG_ENV_SIZE_REDUND		(CFG_ENV_SECT_SIZE)
*/

/*
#define CFG_JFFS2_FIRST_BANK		(0)
#define CFG_JFFS2_FIRST_SECTOR		(31)
#define CFG_JFFS2_NUM_BANKS		(1)
*/
/* */
#include <ep93xx.h>
#define CONFIG_SOFT_I2C
#define CFG_I2C_SLAVE			0
#define CFG_I2C_SPEED			50000
#define I2C_READ			((GPIO_PGDR & 0x2) != 0)
#define I2C_ACTIVE	(GPIO_PGDDR |= 0x2)
#define I2C_TRISTATE	(GPIO_PGDDR &= ~0x2)
#define I2C_SDA(bit)	if(bit) GPIO_PGDR |= 0x2; \
			else    GPIO_PGDR &= ~0x2;
#define I2C_SCL(bit)	if(bit) GPIO_PGDR |= 0x1; \
			else    GPIO_PGDR &= ~0x1;
#define I2C_DELAY	udelay(5)

#define CONFIG_SPI			1
#define CFG_EEPROM_ERASE		1
#define CFG_EEPROM_INFO			1
#if 0
#define CFG_EEPROM_PAGE_WRITE_BITS	8	/* 256 byte per page	*/
#define CFG_EEPROM_PAGE_WRITE_DELAY_MS	10	/* and takes up to 10 msec */
#endif

/*
#define CONFIG_DOS_PARTITION		1
#define __LITTLE_ENDIAN			1
#define __LITTLE_ENDIAN_BITFIELD	1
*/

#define CONFIG_LCD			1
#define CONFIG_LCD_LOGO			1
/*#define CONFIG_LCD_INFO_BELOW_LOGO	1
#define CONFIG_LCD_INFO			1*/
/* LCD  */
#define LCD_BPP				LCD_COLOR8
#define CFG_CONSOLE_IS_IN_ENV		1
#define CONFIG_EP93XX_SDCS3		1
/*
#define LCD_BPP				LCD_COLOR16
*/

#define CONFIG_RTC_DS1337		1
#define CFG_I2C_RTC_ADDR		0x68

#define CONFIG_HW_WATCHDOG		1
#define CONFIG_MISC_INIT_R		1

#endif /* !defined(TB0319_H) */

